(defproject fluree.db/server "0.12.0"
  :description "FlureeDB Server, containing ability to start as a ledger, query peer, or both (dev)."
  :url "https://www.flur.ee"

  :dependencies [[org.clojure/clojure "1.10.1"]
                 [fluree/db "0.12.0"]
                 [fluree/raft "0.11.1"]
                 [fluree.crypto "0.3.1"]

                 ;; network comm
                 [net.async/async "0.1.0"]

                 ;; web server
                 [aleph-middleware "0.2.0" :exclusions [aleph-middleware aleph]]
                 [ring/ring-core "1.7.0"]
                 [ring-cors "0.1.12"]
                 [compojure "1.6.1"]]

  :main ^:skip-aot fluree.db.server
  :target-path "target/%s"
  :profiles {:uberjar {:aot :all}
             :dev     {:source-paths ["dev"]
                       :env          {:dev                 "true"
                                      :fdb-mode            "dev"
                                      :fdb-properties-file ""}
                       :repl-options {:init-ns user
                                      :init    nil #_(reset)}
                       :dependencies [[lein-environ "1.1.0"]
                                      [org.clojure/tools.namespace "0.2.11"]
                                      [criterium "0.4.4"]]}})
