# Changelog

## 0.12.0
- React Wrapper: Improve Time Travel Widget [FC-89]
- Fix Queries where last subject is split across multiple nodes, only includes part of the subject [FC-166]
- Verify that large transactions (up to 2MB) are properly handled, without crashing [FC-175]
- Fluree-React Wrapper not receiving updated blocks when ledger updated [FC-234]
- Fix block range query was not responding [FC-240]
- ISO-8601 strings not accepted in /block queries [FC-241]
- History query not working when block not provided [FC-268]
- Flureeworker ignores block when specified in a query [FC-273]
- Flureedb transaction ids do not match expected values/formats [FC-274]

## 0.11.7

- Ensure history qurey returns proper response without block having to be specified.

## 0.11.6

- Ensure private key properly decrypted in JWT token.

## 0.11.5 
- Fix block range query was not responding 

## 0.11.4

- Ensure nested transaction doesn't create duplicate tempids. This appears to have been overwritten. 

## 0.11.3

- Ensure encryption-at-rest for enterprise customers properly writing to file [EC-28]

## 0.11.2

- Fix issue with nested transactions (same as 0.10.7, but never merged).

## 0.11.1 

- Ensure fdb-api-open was being read properly from settings.

## 0.11.0

- Support Password Authentication for Private Key Generation [FC-13]
- Archive databases + create database from archive [FC-30]
- Check if in 0.9.6, setting two predicates to null retracts both of them, or just the first one. [FC-69]
- Make db names a-z0-9-, including upgrade script [FC-70]
- Deletion of multiple predicates at once was failing in certain circumstances [FC-75]
- Removed fdb-sendgrid-auth from server settings [FC-86]
- Support Delete Ledger action [FC-90]
- Add permissioned flake filtering to index and block retrieval, along with block push via websockets [FC-93]
- Create API to get Password-Auth JWT token [FC-95]
- JavaScript-Compiled APIs: Signed queries should be submitted as commands to the server [FC-148]
- Incorporate Password-Auth JWT token in cljs api library [FC-150]
- _tx/tempids has an empty map "{}" in tx flakes when no tempids. Should not be included in block at all if empty. [FC-152]
- Create api to renew JWT tokens [FC-158]
- Check for JWT tokens in http API and sign requests as needed [FC-162]
- Data version upgrade triggers with new instance [FC-167]
- Create Build constants namespace/file [FC-168]
- Fluree React Wrapper: Wire-Up DB Connection Event [FC-170]
- Raft DB Sync Inconsistency [FC-174]
- Test that large transactions (up to 2MB) are properly handled, without crashing. [FC-175]
- Lagging back-slash causes 404 [FC-178]
- Change "archive" naming to "snapshot" [FC-185]
- Create database from snapshot should throw error if snapshot file incorrect. [FC-212]

## 0.10.9

- Ensure nested transaction doesn't create duplicate tempids.

## 0.10.8

- Ensure query that retrieves signed command results goes to the correct endpoint. 

## 0.10.7

- Fix bug where nested transactions using subject ids failed.

## 0.10.6

- Allow queries in smart functions to be a string

## 0.10.5

- Add DEBUG logging for smart function (back in?)
- Switch the name for nil? and empty? smart functions (names were flipped)

## 0.10.4

- Bump React version in UI to re-enable Schema page. 

## 0.10.3

- Ensure fdb-api-open setting is deactivated when fdb-api-open is set to false
- Add DEBUG logging for http-signatures (when fdb-api-open = true only)

## 0.10.2

- In the UI, allow 'host' to be viewed and changed when signing queries 
- Fix issue with unique two-tuples not being recognized as references 

## 0.10.1

- Ensure JSON-type predicates are not mistaken for nested transactions
- Add DEBUG logging for smart functions

## 0.10.0

- Switch to semantic version (previous version 0.9.5 is 0.10.0)
- Raft checks every block and log file when starting up or server rejoins the network.
- Top-level sort capabilities in GraphQL and FlureeQL
- Ensure settings are determined in order of precedence: Environmental Variables, Java Property Flags (-Dxxxx), .properties file.


## 0.9.5-PREVIEW2

- Raft snapshots only happening at reboots, not purging
- Multi-cardinality recursion fix
- Multi-cardinality delete transaction fix

